# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities, tables

class AttachedDisk(pulumi.CustomResource):
    """
    Persistent disks can be attached to a compute instance using [the `attached_disk`
    section within the compute instance configuration](https://www.terraform.io/docs/providers/google/r/compute_instance.html#attached_disk).
    However there may be situations where managing the attached disks via the compute
    instance config isn't preferable or possible, such as attaching dynamic
    numbers of disks using the `count` variable.
    
    
    To get more information about attaching disks, see:
    
    * [API documentation](https://cloud.google.com/compute/docs/reference/rest/v1/instances/attachDisk)
    * [Resource: google_compute_disk](https://www.terraform.io/docs/providers/google/r/compute_disk.html)
    * How-to Guides
        * [Adding a persistent disk](https://cloud.google.com/compute/docs/disks/add-persistent-disk)
    
    """
    def __init__(__self__, __name__, __opts__=None, device_name=None, disk=None, instance=None, mode=None, project=None, zone=None):
        """Create a AttachedDisk resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        __props__['device_name'] = device_name

        if not disk:
            raise TypeError('Missing required property disk')
        __props__['disk'] = disk

        if not instance:
            raise TypeError('Missing required property instance')
        __props__['instance'] = instance

        __props__['mode'] = mode

        __props__['project'] = project

        __props__['zone'] = zone

        super(AttachedDisk, __self__).__init__(
            'gcp:compute/attachedDisk:AttachedDisk',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

